/** COMPILATION ISSUES
 * See also https://nodejs.org/api/packages.html
 * '"type": "module",' is required in 'package.json'
 * Do not compile with '"strict": true,':
 */
import Quagga from 'quagga'; // '"moduleResolution": "Node",' is mandatory...
// const Quagga = require('quagga').default; // 'CommonJS'
// Bundling: https://developers.cloudflare.com/workers/wrangler/bundling/
export default async function Extract_barcode_from_photography(): Promise<string> {
    return new Promise(barcode => {
        Quagga.default.decodeSingle({ // https://serratus.github.io/quaggaJS/#configobject
            decoder: {
                readers: ["ean_reader"]
            },
            inputStream: {
                name: "better_food",
                type: "ImageStream"
            },
            locate: true, // Default
            numOfWorkers: 0, // Needs to be '0' when used within Node.js...
            src: "./barcode/Coconut_milk.jpg"
        }, data => {
            console.info(data.codeResult ? data.codeResult.code : "No barcode found...");
            barcode(data.codeResult ? data.codeResult.code : "No barcode found...");
        });
    });
}

// CloudFlare worker's handler:
addEventListener('fetch', (event: FetchEvent) => {
    console.log("'request.url': " + event.request.url);
event.respondWith("T");
// Quagga.default.decodeSingle({ // https://serratus.github.io/quaggaJS/#configobject
//     decoder: {
//         readers: ["ean_reader"]
//     },
//     inputStream: {
//         name: "better_food",
//         type: "ImageStream"
//     },
//     locate: true, // Default
//     numOfWorkers: 0, // Needs to be '0' when used within Node.js...
//     src: "./barcode/Coconut_milk.jpg"
// }, data => {
//     console.info(data.codeResult ? data.codeResult.code : "No barcode found...");
// });
});

